#pragma once

#include <dune/common/typeutilities.hh>
#include <dune/functions/common/functionfromcallable.hh>

namespace AMDiS
{
  namespace Impl
  {
    template <class Traits, class F,
      class Range = typename Traits::RangeType,
      class Domain = typename Traits::DomainType>
    auto functionFromCallableImpl(F const& f, Dune::PriorityTag<2>)
    {
      return Dune::Functions::FunctionFromCallable<Range(Domain), F>(f);
    }

    template <class Signature, class F>
    auto functionFromCallableImpl(F const& f, Dune::PriorityTag<1>)
    {
      return Dune::Functions::FunctionFromCallable<Signature, F>(f);
    }
  }

  template <class SigTraits, class F>
  auto functionFromCallable(F const& f)
  {
    return Impl::functionFromCallableImpl<SigTraits>(f, Dune::PriorityTag<10>{});
  }

} // end namespace AMDiS
