#pragma once

#include <type_traits>

#include <amdis/localoperators/FirstOrderTestPartialTrial.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct partialtest_trial
    {
      std::size_t comp;
    };

    struct partial_test
    {
      std::size_t comp;
    };
  }


  /// first-order operator \f$ \langle\partial_i\psi, c\,\phi\rangle \f$
  template <class LC, class GridFct>
  class GridFunctionOperator<tag::partialtest_trial, LC, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::partialtest_trial, LC, GridFct>,
                                              GridFunctionOperator<tag::test_partialtrial, LC, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::test_partialtrial, LC, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::partialtest_trial tag, GridFct const& expr)
      : Super(tag::test_partialtrial{tag.comp}, expr)
    {}
  };


  /// Create a first-order term with derivative on trial-function
  template <class Expr, class... QuadratureArgs>
  auto fot(Expr&& expr, tag::partial_test t, QuadratureArgs&&... args)
  {
    return makeOperator(tag::partialtest_trial{t.comp}, FWD(expr), FWD(args)...);
  }

  /** @} **/

} // end namespace AMDiS
