#pragma once

#include <type_traits>

#include <amdis/localoperators/ZeroOrderTestTrialvec.hpp>

namespace AMDiS
{
  /**
   * \addtogroup operators
   * @{
   **/

  namespace tag
  {
    struct testvec_trial {};
  }


  /// zero-order operator \f$ \langle\Psi, \mathbf{b}\,\phi\rangle \f$
  template <class LC, class GridFct>
  class GridFunctionOperator<tag::testvec_trial, LC, GridFct>
      : public GridFunctionOperatorTransposed<GridFunctionOperator<tag::testvec_trial, LC, GridFct>,
                                              GridFunctionOperator<tag::test_trialvec, LC, GridFct>>
  {
    using Self = GridFunctionOperator;
    using Transposed = GridFunctionOperator<tag::test_trialvec, LC, GridFct>;
    using Super = GridFunctionOperatorTransposed<Self, Transposed>;

  public:
    GridFunctionOperator(tag::testvec_trial, GridFct const& expr)
      : Super(tag::test_trialvec{}, expr)
    {}
  };

  /** @} **/

} // end namespace AMDiS
